export declare interface Pos {
  lnum: number
  col: number
  offset: number
}

export declare interface Node {
  type: number
  pos: Pos
  body: Node[]
  ea: {
    linepos: Pos
    cmdpos: Pos
    argpos: Pos
    cmd: {
      name: string
    }
  }
  op?: string
  left: Node
  right: Node
  rlist: Node[]
  str: string
  value?: any
}

export declare class StringReader {
  constructor(str: string)
  buf: string[]
  pos: Array<[number, number, number]>
}

export declare class VimLParser {
  constructor(isNeovim: boolean)
  parse(stringReader: StringReader): Node
}

