"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var vscode_languageserver_1 = require("vscode-languageserver");
var builtin_1 = require("../server/builtin");
var kinds_1 = require("../server/kinds");
function getHover(params, documents) {
    var textDocument = params.textDocument, position = params.position;
    var doc = documents.get(textDocument.uri);
    if (!doc) {
        return;
    }
    var character = doc.getText(vscode_languageserver_1.Range.create(vscode_languageserver_1.Position.create(position.line, position.character), vscode_languageserver_1.Position.create(position.line, position.character + 1)));
    // not keyword position
    if (!character || !kinds_1.keywordPattern.test(character)) {
        return;
    }
    var currentLine = doc.getText(vscode_languageserver_1.Range.create(vscode_languageserver_1.Position.create(position.line, 0), vscode_languageserver_1.Position.create(position.line + 1, 0)));
    // comment line
    if (kinds_1.commentPattern.test(currentLine)) {
        return;
    }
    var preSegment = currentLine.slice(0, position.character);
    var nextSegment = currentLine.slice(position.character);
    var wordLeft = preSegment.match(kinds_1.wordPrePattern);
    var wordRight = nextSegment.match(kinds_1.wordNextPattern);
    var word = "" + (wordLeft && wordLeft[1] || '') + (wordRight && wordRight[1] || '');
    return builtin_1.server.getHoverDocument(word, wordLeft && wordLeft[1] ? preSegment.replace(new RegExp(wordLeft[1] + "$"), word) : "" + preSegment + word, wordRight && wordRight[1] ? nextSegment.replace(new RegExp("^" + wordRight[1]), word) : "" + word + nextSegment);
}
exports.getHover = getHover;
//# sourceMappingURL=hover.js.map