import { IConfig } from '../util/types';
import { CompletionItem, CompletionItemKind, Hover, SignatureHelp } from 'vscode-languageserver';
declare class Server {
    constructor();
    private config;
    private vimPredefinedVariablesItems;
    private vimOptionItems;
    private vimBuiltinFunctionItems;
    private vimCommandItems;
    private vimMapArgsItems;
    private vimFeatureItems;
    private expandKeywordItems;
    private colorschemeItems;
    private vimBuiltFunctionSignatureHelp;
    private vimBuiltFunctionDocuments;
    private vimOptionDocuments;
    private vimPredefinedVariableDocuments;
    private vimCommandDocuments;
    private vimFeatureDocuments;
    private expandKeywordDocuments;
    init(config: IConfig): void;
    getPredefinedVimVariables(): CompletionItem[];
    getVimOptions(): CompletionItem[];
    getBuiltinVimFunctions(): CompletionItem[];
    getExpandKeywords(): CompletionItem[];
    getVimCommands(): CompletionItem[];
    getVimMapArgs(): CompletionItem[];
    getVimFeatures(): CompletionItem[];
    getColorschemes(): CompletionItem[];
    getSignatureHelpByName(name: string, idx: number): SignatureHelp | undefined;
    getDocumentByCompletionItem(params: {
        label: string;
        kind: CompletionItemKind;
    } | CompletionItem): CompletionItem | undefined;
    getHoverDocument(name: string, pre: string, next: string): Hover;
    private start;
    private formatVimDocument;
    private resolveMapArgs;
    private resolveColorschemes;
}
export declare const server: Server;
export {};
