"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorLinePattern = /[^:]+:\s*(.+?):\s*line\s*([0-9]+)\s*col\s*([0-9]+)/;
exports.commentPattern = /^[ \t]*("|')/;
exports.keywordPattern = /[\w#&:]/;
exports.functionPattern = /^((<sid>|\b(v|g|b|s|l|a):)?[\w#&]+)[ \t]*\([^)]*\)/;
exports.wordPrePattern = /^.*?(((<sid>|\b(v|g|b|s|l|a):)?[\w#&]+)|(<sid>|\b(v|g|b|s|l|a):))$/;
exports.wordNextPattern = /^((<sid>|\b(v|g|b|s|l|a):)?[\w#&]+|(<sid>|\b(v|g|b|s|l|a):)|(:[\w#&]+)).*?(\r\n|\r|\n)?$/;
exports.colorschemePattern = /\bcolorscheme[ \t]+\w*$/;
exports.mapCommandPattern = /^([ \t]*(\[ \t]*)?)\w*map[ \t]+/;
exports.builtinVariablePattern = [
    /(^|[ \t]+)v:\w*$/
];
exports.optionPattern = [
    /(^|[ \t]+)&\w*$/,
    /(^|[ \t]+)set(l|local|g|global)?[ \t]+\w+$/
];
exports.BuiltinFunctionPattern = [
    /^[ \t]*\w+$/,
    /^[ \t]*"/,
    /(let|set)[ \t][^ \t]+$/,
    /[^([,\\ \t\w#]\w*$/
];
exports.notBuiltinFunctionPattern = [
    /^[ \t]*\w+$/,
    /^[ \t]*"/,
    /(let|set|colorscheme)[ \t][^ \t]*$/,
    /[^([,\\ \t\w#]\w*$/
];
exports.commandPattern = [
    /(^|[ \t]):\w+$/,
    /^[ \t]*\w+$/,
    /:?silent!?[ \t]\w+/
];
exports.featurePattern = [
    /\bhas\([ \t]*["']\w*/
];
exports.expandPattern = [
    /\bexpand\(['"]<\w*$/,
    /\bexpand\([ \t]*['"]\w*$/
];
//# sourceMappingURL=kinds.js.map