"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var waitMap_1 = require("rxjs-operators/lib/waitMap");
var vimparser_1 = require("../../lib/vimparser");
var diagnostic_1 = require("../handles/diagnostic");
var parserHandles = {};
var origin$ = new rxjs_1.Subject();
function handleParse(textDoc) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var text, tokens, node;
        return tslib_1.__generator(this, function (_a) {
            text = textDoc.getText();
            tokens = new vimparser_1.StringReader(text);
            try {
                node = new vimparser_1.VimLParser(true).parse(tokens);
                return [2 /*return*/, [node, '']];
            }
            catch (error) {
                return [2 /*return*/, [null, error]];
            }
            return [2 /*return*/];
        });
    });
}
function next(textDoc, con) {
    if (!parserHandles[textDoc.uri]) {
        var languageId_1 = textDoc.languageId;
        parserHandles[textDoc.uri] = origin$.pipe(operators_1.filter(function (textDoc) { return textDoc.languageId === languageId_1; }), operators_1.switchMap(function (textDoc) {
            return rxjs_1.timer(100).pipe(operators_1.map(function () { return textDoc; }));
        }), waitMap_1.waitMap(function (textDoc) {
            return rxjs_1.from(handleParse(textDoc));
        }, true)).subscribe(function (res) {
            // handle diagnostic
            diagnostic_1.handleDiagnostic(textDoc, res[1]);
        }, function (err) {
            con.console.error("[" + languageId_1 + "]: parse buffer error: " + err.message);
        });
    }
    origin$.next(textDoc);
}
exports.next = next;
function unsubscribe(textDoc) {
    if (parserHandles[textDoc.uri] !== undefined) {
        parserHandles[textDoc.uri].unsubscribe();
    }
    parserHandles[textDoc.uri] = undefined;
}
exports.unsubscribe = unsubscribe;
//# sourceMappingURL=parser.js.map